/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 1.3.33
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package com.sleepycat.dbxml;

import java.util.*;

public class XmlQueryContext {
    public final static int LiveValues = 0;

    public final static int Eager = 0;
    public final static int Lazy = Eager + 1;

    protected XmlManager mgr;
    protected HashMap variables;
    protected HashMap namespaces;
    protected String baseURI;
    protected int evaluationType;
    protected String defaultCollection;
    protected int queryInterruptSec;
    protected String defaultCollectionURI;
    protected Interrupter interrupt;

    protected XmlQueryContext(int rt, int et) {
	evaluationType = et;
	interrupt = new Interrupter();
    }

    public XmlQueryContext(XmlQueryContext o) throws XmlException {
	baseURI = o.baseURI;
	evaluationType = o.evaluationType;
	defaultCollection = o.defaultCollection;
	queryInterruptSec = o.queryInterruptSec;
	if(o.namespaces != null) namespaces = new HashMap(o.namespaces);
	if(o.variables != null)variables = new HashMap(o.variables);
	interrupt = new Interrupter();
	mgr = o.mgr;
    }

    public void delete(){}

    public void setVariableValue(String name, XmlValue value) throws XmlException {
	if (value.getType() == XmlValue.BINARY)
	    throw (new XmlException(XmlException.INVALID_VALUE, "XmlQueryContext::setVariableValue value cannot be binary"));
	if(variables == null) variables = new HashMap();
	XmlValue[] val = {value};
	variables.put(name, val);
    }

    public void setVariableValue(String name, XmlResults value) throws XmlException {
	if(variables == null) variables = new HashMap();
	if(value.getEvaluationType() == XmlQueryContext.Lazy){
	    XmlResults res = new XmlResults(value);
	    XmlValue[] values = new XmlValue[res.size()];
	    for(int i = 0; i < values.length; i++)
		values[i] = res.next();
	    variables.put(name, values);
	    res.delete();
	    return;
	}
	value.reset();
	XmlValue[] values = new XmlValue[value.size()];
	for(int i = 0; i < values.length; i++)
	    values[i] = value.next();
	variables.put(name, values);
    }
    public XmlValue getVariableValue(String name) throws XmlException { 
	if(variables == null) return new XmlValue();
	XmlValue[] value = (XmlValue[])variables.get(name);
	if(value == null || value.length == 0)
	    return new XmlValue();
	if(value.length > 1)
	    throw (new XmlException(XmlException.INVALID_VALUE, "Variable has more than one value assigned to it"));
	return value[0];
    }

    public XmlResults getVariableValues(String name) throws XmlException {
	if(variables == null) return null;
	XmlValue[] res = (XmlValue[])variables.get(name);
	if(res != null){
	    XmlResults result = mgr.createResults();
	    for(int i = 0; i < res.length; i++)
		result.add(res[i]);
	    return result;
	}
	return null;
    }

    public void setNamespace(String prefix, String uri) throws XmlException {
	if(namespaces == null) namespaces = new HashMap();
	namespaces.put(prefix, uri);
    }

    public String getNamespace(String prefix) throws XmlException {
	if(prefix.equalsIgnoreCase(dbxml_javaConstants.metaDataNamespace_prefix)) 
	    return dbxml_javaConstants.metaDataNamespace_prefix;
	if(namespaces == null) return "";
	String uri = (String)namespaces.get(prefix);
	if(uri == null)
	    return "";
	return uri;
    }

    public void removeNamespace(String prefix) throws XmlException {
	if(namespaces != null)
	    namespaces.remove(prefix);
    }

    public void clearNamespaces() throws XmlException {
	if(namespaces != null)
	    namespaces.clear();
    }

    public void setBaseURI(String baseURI) throws XmlException {
	HelperFunctions.verifyBaseURI(mgr, baseURI);
	this.baseURI = baseURI;
    }

    public String getBaseURI() throws XmlException {
	if(baseURI == null) return "dbxml:/";
	return baseURI;
    }

    //No-op at the moment since the only return type is LiveValues
    public void setReturnType(int type) throws XmlException {
    }

    public int getReturnType() throws XmlException {
	return LiveValues;
    }

    public void setEvaluationType(int type) throws XmlException {
	this.evaluationType = type;
    }

    public int getEvaluationType() throws XmlException {
	return evaluationType;
    }

    public void setDefaultCollection(String uri) throws XmlException {
	defaultCollection = HelperFunctions.verifyDefaultCollection(mgr, uri, baseURI);
	defaultCollectionURI = uri;
    }

    public String getDefaultCollection() throws XmlException {
	if(defaultCollection == null) return "";
	return defaultCollection;
    }

    public void interruptQuery() throws XmlException {
	synchronized(interrupt){
	    if(interrupt.cPtr != 0) dbxml_javaJNI.interruptQuery(interrupt.cPtr);
	}
    }

    public void setQueryTimeoutSeconds(int secs) throws XmlException {
	queryInterruptSec = secs;
    }

    public int getQueryTimeoutSeconds() throws XmlException {
	return queryInterruptSec;
    }

    protected static XmlQueryContext copy(XmlQueryContext o) throws XmlException {
	return new XmlQueryContext(o);
    }

    //Used by createCPPXmlQueryContext to translate the object to a C++ XmlQueryContext
    protected long getManagerPtr()
    {
	return XmlManager.getCPtr(mgr);
    }

    /*
     * pack() combines most of the information for XmlQueryContext into an
     * Object array and returns it to the JNI so a C++ XmlQueryContext can be
     * made.  The first spot in the array contains the baseURI, which can be null,
     * the second spot contains the unresolved default collection, which can also
     * be null.  Next all namespace prefixes and uris are added, if any exist.
     * Then a null is added to separate the namespaces and variables.  Next
     * the variables are added.  The name of the variable is added, then
     * the array containing all XmlValue values for that name are added.
     * The format is baseURI, defaultCollection, [namespace prefix,
     * namespace uri, ..] null [variable name, XmlValue array of variable values, ..]
     */
    protected Object[] pack() throws XmlException
    {
	Vector data = new Vector();
	data.add(baseURI);
	data.add(defaultCollectionURI);
	if(namespaces != null){
	    Iterator namespaceIter = namespaces.entrySet().iterator();
	    while(namespaceIter.hasNext()){
		Map.Entry entry = (Map.Entry)namespaceIter.next();
		data.add(entry.getKey());
		data.add(entry.getValue());
	    }
	}
	data.add(null);
	if(variables != null){
	    Iterator variableIter = variables.entrySet().iterator();
	    while(variableIter.hasNext()){
		Map.Entry entry = (Map.Entry)variableIter.next();
		data.add(entry.getKey());
		XmlValue[] res = (XmlValue[])entry.getValue();
		data.add(res);
	    }
	}
	return data.toArray();
    }

    protected void setCPtr(long ptr)
    {
	synchronized (interrupt){
	    interrupt.cPtr = ptr;
	}
    }

    class Interrupter{
	public long cPtr;
    }
}
